Sets
         n node          / 1*22 /
         l line          / 1*33 /
         t hour index    / 1*24 /
         a area          / NO1, NO2, NO3, NO4, NO5 / ;

Alias(l,ll);

*=== Import from Excel: Network parameters =====================================
Parameter Pmin(n) Minimum production capacity in node n [MW];
$call GDXXRW parameters.xlsx trace=3 par=Pmin rng=pmin!A1:B22 rdim=1 cdim=0
$GDXIN parameters.gdx
$LOAD Pmin
$GDXIN

Parameter Pmax(n) Maximum production capacity in node n [MW];
$call GDXXRW parameters.xlsx trace=3 par=Pmax rng=pmax!A1:B22 rdim=1 cdim=0
$GDXIN parameters.gdx
$LOAD Pmax
$GDXIN

Parameter Pcap(l) Transmission capacity in line l [MW];
$call GDXXRW parameters.xlsx trace=3 par=Pcap rng=transmission!A1:B33 rdim=1 cdim=0
$GDXIN parameters.gdx
$LOAD Pcap
$GDXIN

Parameter Nc(n) Indicator of battery connection (=0 if no battery in node n and =1 if 1 batery in node n);
$call GDXXRW parameters.xlsx trace=3 par=Nc rng=batteryconnection!A1:B22 rdim=1 cdim=0
$GDXIN parameters.gdx
$LOAD Nc
$GDXIN
*===============================================================================

*=== Import from Excel: Battery parameters =====================================
Parameter eta Charging efficiency for battery;
$call GDXXRW battery.xlsx trace=3 par=eta rng=battery!B1:B1 rdim=0 cdim=0
$GDXIN battery.gdx
$LOAD eta
$GDXIN

Parameter Pcmin Minimum charging power for battery [MW];
$call GDXXRW battery.xlsx trace=3 par=Pcmin rng=battery!B2:B2 rdim=0 cdim=0
$GDXIN battery.gdx
$LOAD Pcmin
$GDXIN

Parameter Pcmax Maximum charging power for battery [MW];
$call GDXXRW battery.xlsx trace=3 par=Pcmax rng=battery!B3:B3 rdim=0 cdim=0
$GDXIN battery.gdx
$LOAD Pcmax
$GDXIN

Parameter Pdcmin Minimum discharging power for battery [MW];
$call GDXXRW battery.xlsx trace=3 par=Pdcmin rng=battery!B4:B4 rdim=0 cdim=0
$GDXIN battery.gdx
$LOAD Pdcmin
$GDXIN

Parameter Pdcmax Maximum discharging power for battery [MW];
$call GDXXRW battery.xlsx trace=3 par=Pdcmax rng=battery!B5:B5 rdim=0 cdim=0
$GDXIN battery.gdx
$LOAD Pdcmax
$GDXIN

Parameter Emin Minimum available energy for battery [MWh];
$call GDXXRW battery.xlsx trace=3 par=Emin rng=battery!B6:B6 rdim=0 cdim=0
$GDXIN battery.gdx
$LOAD Emin
$GDXIN

Parameter Emax Maximum available energy for battery [MWh];
$call GDXXRW battery.xlsx trace=3 par=Emax rng=battery!B7:B7 rdim=0 cdim=0
$GDXIN battery.gdx
$LOAD Emax
$GDXIN
*===============================================================================

*=== Import from Excel: Day-ahead prices from NordPool =========================
$onecho > nordpool.txt
I="%system.fp%nordpool.xlsx"
R=dayahead!A1:F25
O=dayahead.inc
$offecho
$call =xls2gms @nordpool.txt
table price(t,a)
$include dayahead.inc
;

Parameter pricet(a,t)  Day-ahead price transposed [EUR];
pricet(a,t) =  price(t,a);

Parameter lambda(n,t) Day-ahead price [EUR];
lambda('1',t) = pricet('NO1',t);
lambda('2',t) = pricet('NO1',t);
lambda('3',t) = pricet('NO1',t);
lambda('4',t) = pricet('NO1',t);
lambda('5',t) = pricet('NO5',t);
lambda('6',t) = pricet('NO5',t);
lambda('7',t) = pricet('NO1',t);
lambda('8',t) = pricet('NO1',t);
lambda('9',t) = pricet('NO1',t);
lambda('10',t) = pricet('NO1',t);
lambda('11',t) = pricet('NO2',t);
lambda('12',t) = pricet('NO2',t);
lambda('13',t) = pricet('NO2',t);
lambda('14',t) = pricet('NO2',t);
lambda('15',t) = pricet('NO2',t);
lambda('16',t) = pricet('NO2',t);
lambda('17',t) = pricet('NO2',t);
lambda('18',t) = pricet('NO2',t);
lambda('19',t) = pricet('NO5',t);
lambda('20',t) = pricet('NO3',t);
lambda('21',t) = pricet('NO4',t);
lambda('22',t) = pricet('NO4',t);


*=== Import from Excel: Average day-ahead prices from NordPool =================
Parameter CNO1 Charging cost & discharging earning for NO1 [EUR per MWh];
$call GDXXRW.EXE nordpool.xlsx trace=3 par=CNO1 rng=dayahead!B26:B26  rdim=0 cdim=0
$GDXIN nordpool.gdx
$LOAD CNO1
$GDXIN

Parameter CNO2 Charging cost & discharging earning for NO2 [EUR per MWh];
$call GDXXRW.EXE nordpool.xlsx trace=3 par=CNO2 rng=dayahead!C26:C26  rdim=0 cdim=0
$GDXIN nordpool.gdx
$LOAD CNO2
$GDXIN

Parameter CNO3 Charging cost & discharging earning for NO3  [EUR per MWh];
$call GDXXRW.EXE nordpool.xlsx trace=3 par=CNO3 rng=dayahead!E26:E26  rdim=0 cdim=0
$GDXIN nordpool.gdx
$LOAD CNO3
$GDXIN

Parameter CNO4 Charging cost & discharging earning for NO4 [EUR per MWh];
$call GDXXRW.EXE nordpool.xlsx trace=3 par=CNO4 rng=dayahead!F26:F26  rdim=0 cdim=0
$GDXIN nordpool.gdx
$LOAD CNO4
$GDXIN

Parameter CNO5 Charging cost & discharging earning for NO5 [EUR per MWh];
$call GDXXRW.EXE nordpool.xlsx trace=3 par=CNO5 rng=dayahead!D26:D26  rdim=0 cdim=0
$GDXIN nordpool.gdx
$LOAD CNO5
$GDXIN

Parameter C(n) Charging cost & discharging earning [EUR per MWh];
C('1') = CNO1;
C('2') = CNO1;
C('3') = CNO1;
C('4') = CNO1;
C('5') = CNO5;
C('6') = CNO5;
C('7') = CNO1;
C('8') = CNO1;
C('9') = CNO1;
C('10') = CNO1;
C('11') = CNO2;
C('12') = CNO2;
C('13') = CNO2;
C('14') = CNO2;
C('15') = CNO2;
C('16') = CNO2;
C('17') = CNO2;
C('18') = CNO2;
C('19') = CNO5;
C('20') = CNO3;
C('21') = CNO4;
C('22') = CNO4;
*===============================================================================

*=== Import from Excel: Consumption data from NordPool =========================
$onecho > nordpool.txt
I="%system.fp%nordpool.xlsx"
R=demand!A1:F25
O=demand.inc
$offecho
$call =xls2gms @nordpool.txt
table demand(t,a)
$include demand.inc
;

Parameter demandt(a,t) Demand transposed [MW];
demandt(a,t) = demand(t,a);

Parameter  Pdem(n,t) Demand [MW];
Pdem('1',t) = demandt('NO1',t)*0.7608;
Pdem('2',t) = 0;
Pdem('3',t) = 0;
Pdem('4',t) = 0;
Pdem('5',t) = demandt('NO5',t)*0.0620;
Pdem('6',t) = 0;
Pdem('7',t) = demandt('NO1',t)*0.0171;
Pdem('8',t) = 0;
Pdem('9',t) = demandt('NO1',t)*0.2221;
Pdem('10',t) = 0;
Pdem('11',t) = demandt('NO2',t)*0.8706;
Pdem('12',t) = 0;
Pdem('13',t) = 0;
Pdem('14',t) = demandt('NO2',t)*0.1283;
Pdem('15',t) = 0;
Pdem('16',t) = 0;
Pdem('17',t) = demandt('NO2',t)*0.0011;
Pdem('18',t) = 0;
Pdem('19',t) = demandt('NO5',t)*0.9380;
Pdem('20',t) = demandt('NO3',t);
Pdem('21',t) = demandt('NO4',t);
Pdem('22',t) = 0;
*===============================================================================

*=== Import from Excel: Exchange data between Norway and neighbouring countries, from NordPool
$onecho > nordpool.txt
I="%system.fp%nordpool.xlsx"
R=exchange!A2:G26
O=exchange.inc
$offecho
$call =xls2gms @nordpool.txt
table exchange(t,n)
$include exchange.inc
;
Parameter  exchanget(n,t) Exchange transposed [MW] ;
exchanget(n,t) =  exchange(t,n);
Parameter Pexc(n,t) Exchange [MW];
Pexc('1',t) = 0;
Pexc('2',t) = exchanget('2',t);
Pexc('3',t) = 0;
Pexc('4',t) = 0;
Pexc('5',t) = 0;
Pexc('6',t) = 0;
Pexc('7',t) = 0;
Pexc('8',t) = 0;
Pexc('9',t) = 0;
Pexc('10',t) = 0;
Pexc('11',t) = 0;
Pexc('12',t) = 0;
Pexc('13',t) = 0;
Pexc('14',t) = 0;
Pexc('15',t) = exchanget('15',t);
Pexc('16',t) = exchanget('16',t);
Pexc('17',t) = 0;
Pexc('18',t) = 0;
Pexc('19',t) = 0;
Pexc('20',t) = exchanget('20',t);
Pexc('21',t) = exchanget('21',t);
Pexc('22',t) = exchanget('22',t);
*===============================================================================


*=== Import from Excel: PTDF-matrix ============================================
$CALL GDXXRW.EXE Norway.xlsx par=PTDF rng=PTDF!A1:W34
Parameter PTDF(l,n);
$GDXIN Norway.gdx
$LOAD PTDF
$GDXIN
*===============================================================================

*=== Import from Excel: Connection-matrix ======================================
$CALL GDXXRW.EXE Norway.xlsx par=K rng=connection!A3:AH25
Parameter K(n,l);
$GDXIN Norway.gdx
$LOAD K
$GDXIN
*===============================================================================

Variables
         z               Total costs
         cb              Total charging costs
         Pc(n,t)         Charging power
         Pdc(n,t)        Discharging power
         Ic(n,t)         Indicator of charging mode
         Idc(n,t)        Indicator of discharging mode
         E(n,t)          Available energy in battery
         Enet(n,t)       Net charged energy in battery
         Pgen(n,t)       Generation
         Pflow(l,t)      Flow in transmission line;

Positive variable P;

Binary variables  Ic, Idc;

*=== Fixing variable E (available energy) to 0 in the end of a periode.=========
E.fx('1','24') = 0;
E.fx('2','24') = 0;
E.fx('3','24') = 0;
E.fx('4','24') = 0;
E.fx('5','24') = 0;
E.fx('6','24') = 0;
E.fx('7','24') = 0;
E.fx('8','24') = 0;
E.fx('9','24') = 0;
E.fx('10','24') = 0;
E.fx('11','24') = 0;
E.fx('12','24') = 0;
E.fx('13','24') = 0;
E.fx('14','24') = 0;
E.fx('15','24') = 0;
E.fx('16','24') = 0;
E.fx('17','24') = 0;
E.fx('18','24') = 0;
E.fx('19','24') = 0;
E.fx('20','24') = 0;
E.fx('21','24') = 0;
E.fx('22','24') = 0;

*=== Equation definitions ======================================================
Equations
         cost                    Total cost

         energynet(n,t)          Net hourly absorbed or injected energy in battery
         chargpowlow(n,t)        Charging power lower boundary
         chargpowup(n,t)         Charging power upper boundary
         dischargpowlow(n,t)     Discharging power lower boundary
         dischargpowup(n,t)      Discharging power upper boundary
         energybal(n,t)          Energy balance
         energylimlow(n,t)       Energy limitations of batteries lower boundary
         energylimup(n,t)        Energy limitations of batteries upper boundary
         gridcon(n,t)            Charge or discharge mode
         energyatm(n,t)          Ensures there to be enough energy to discharge a battery

         generatingpowlow(n,t)   Generated energy lower boundary
         generatingpowup(n,t)    Generated energy upper boundary
         flowtrans(l,t)          Power flow in transmission lines
         plineconstrf(l,t)       Transmission constraint 1
         plineconstrt(l,t)       Transmission constraint 2
         powerbalance(n,t)       Power balance in node n;

*=== Objective function ========================================================
cost..                   z =e= sum((n,t), lambda(n,t)*Pgen(n,t))+sum((n,t),C(n)*(Pc(n,t)-Pdc(n,t)));

*=== Battery contraints ========================================================
energynet(n,t)..         Enet(n,t) =e= eta*Pc(n,t) - Pdc(n,t);
chargpowlow(n,t) ..      Ic(n,t)*Pcmin =l= Pc(n,t);
chargpowup(n,t) ..       Pc(n,t) =l= Ic(n,t)*Pcmax;
dischargpowlow(n,t) ..   Idc(n,t)*Pdcmin =l= Pdc(n,t);
dischargpowup(n,t) ..    Pdc(n,t) =l= Idc(n,t)*Pdcmax;
energybal(n,t) ..        E(n,t) =e= E(n,t--1) + Enet(n,t);
energylimlow(n,t) ..     Emin =l= E(n,t);
energylimup(n,t) ..      E(n,t) =l= Emax;
gridcon(n,t) ..          Idc(n,t) + Ic(n,t) =l= Nc(n);
energyatm(n,t) ..        Pdc(n,t) =l= E(n,t--1);

*=== Network constraints =======================================================
generatingpowlow(n,t) .. Pmin(n) =l= Pgen(n,t);
generatingpowup(n,t) ..  Pgen(n,t) =l= Pmax(n);
flowtrans(l,t)..         Pflow(l,t) =e= sum(n, PTDF(l,n)*(Pgen(n,t)-Pdem(n,t)-Pexc(n,t)+ (Pdc(n,t) - Pc(n,t))*Nc(n)));
plineconstrf(l,t) ..     Pflow(l,t) =l= Pcap(l);
plineconstrt(l,t) ..     -Pflow(l,t) =l= Pcap(l);
powerbalance(n,t) ..     Pgen(n,t) - Pdem(n,t)-Pexc(n,t) - sum(ll, K(n,ll)*Pflow(ll,t))+ (Pdc(n,t) - Pc(n,t))*Nc(n) =e= 0;

Model gen /all/ ;

Solve gen using mip minimizing z ;

Display  Pgen.l, Pflow.l ,Pmax, Pmin, ll,PTDF, Pdem, Pexc, lambda, E.l, C, eta, Emax;

*=== Export to Excel: Results ==================================================
execute_unload 'res.gdx', Pgen, Pflow, E, z, Pc, Pdc, Ic, Idc, Enet, Pdem, Pexc;
execute 'gdxxrw.exe res.gdx Squeeze=N var=Pgen.l      rng=powergen!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=Pflow.l   rng=powerflow!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=E.l      rng=availableenergy!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=Enet.l   rng=netchargedenergy!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=z.l      rng=optimalsolution!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=Pc.l     rng=chargedpower!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=Pdc.l    rng=dischargedpower!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=Ic.l     rng=chargeindication!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N var=Idc.l    rng=dischargeindication!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N par=Pdem     rng=demand!A1'
execute 'gdxxrw.exe res.gdx Squeeze=N par=Pexc     rng=exchange!A1'

